/* Remote PC client source code
 *
 *                by : koby
 *                      koby@in.gr
 * If you like this code, enjoy this site
 *                      http://www.codecraft.tk
 *
 *    Copyright (c) 2003
 *                    koby and www.Codecraft.tk. All rigths reserved
 *    Redistributions of source code must retain the above copyright
 *    notice and the following disclaimer.
 *
 *     THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 *    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 *    ARE DISCLAIMED.
 *
 */

#include <stdio.h>
#include <string.h>

/*#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
*/
#include <winsock.h>
#include <windows.h>


#define MYPORT 4950    // the port users will be connecting to
#define MAXBUFLEN 100

int main(int argc, char *argv[]) {

	WSADATA wsaData;
	int sockfd, numbytes;
	int addr_len;
	struct sockaddr_in their_addr; // connector's address information
	struct hostent *he;
	char str[MAXBUFLEN];

	if (WSAStartup(MAKEWORD(1,1), &wsaData) != 0) {
  		fprintf(stderr, "WSAStartup failed!");
		exit(1);
	}
	if (argc != 2) {
		fprintf(stderr, "usage : %s hostname\n", argv[0]);
		getchar();
		exit(1);
	}

	if ((he=gethostbyname(argv[1])) == NULL) {  // get the host info
		perror("gethostbyname");
		exit(1);
	}

	if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}

	their_addr.sin_family = AF_INET;     // host byte order
	their_addr.sin_port = htons(MYPORT); // short, network byte order
	their_addr.sin_addr = *((struct in_addr *)he->h_addr);
	memset(&(their_addr.sin_zero), '\0', 8); // zero the rest of the struct

	printf("\n COMMANDS\n");
	printf("chdir [DRIVE:][PATH] Changes the current directory to the PATH specified\n");
	printf("bye                  Exit client\n");
	printf("dir                  Displays a list of files and subdirectories in a directory\n");
	printf("info                 Retrieve system information of the remote PC\n");
	printf("msg [MESSAGE]        Pops-up a window with the message to the Remote PC\n");
	printf("rm [FILENAME]        Deletes the FILENAME specified\n");
	printf("view [FILENAME]      View the FILENAME specified\n");

	while(1) {
		printf("\n>");
		gets(str);
		if( !strcmp(str, "bye") )
			break;
		if ((numbytes=sendto(sockfd, str, strlen(str), 0,
			(struct sockaddr *)&their_addr, sizeof(struct sockaddr))) == -1) {
			perror("sendto");
			exit(1);
		}

		addr_len = sizeof(struct sockaddr);
		while( strcmp(str, "***")!=0 ) {
			if ((numbytes=recvfrom(sockfd, str, MAXBUFLEN-1, 0, (struct sockaddr *)&their_addr, &addr_len)) == -1) {
				perror("recvfrom");
				exit(1);
			}
			str[numbytes] = '\0';
			(!strcmp(str, "***")) ? printf("") : printf("%s", str);
		}

	}

	close(sockfd);

	return 0;

}
